// MySynthMain.cpp
// VZ{̂сÃR|[lg̃NXB

#include <windows.h>
#include <math.h>
#include <list>
#include "common.h"
#include "debug.h"
#include "synthBase.h"
#include "MySynthMain.h"

// g`e[u
#define	WT_SIZE		1024				// g`e[uTCY(Pʂ̓Tv)
static SIGREAL g_sinTable[WT_SIZE];		// TCge[u
static SIGREAL g_triTable[WT_SIZE*68];	// Opge[uigш斈ɕj
static SIGREAL g_sawTable[WT_SIZE*68];	// mRM
static SIGREAL g_squTable[WT_SIZE*68];	// `

// g`e[u
typedef struct tagTableInfo{
	float freq;		// g
	float noteNo;	// gɑΉMIDIm[gNo
	int harmoNum;	// {
	int offset;		// Ήg`e[u̐擪ւ̃ItZbg
} TABLEINFO;
static TABLEINFO g_tblInfo[68+1];	// e[u\
static int g_tblInfoNum;			// e[u\̍s


/////////////////////////////////////////////////////////////////////
// g`e[ȕ֘A
#define _SIN(a)	(g_sinTable[(a)%WT_SIZE])	// sin()֐̑Ƀe[ugAe[u

// Opge[u
static void makeTriTable(SIGREAL* pOutBuf, int harmoNum){
	for(int i=0;i<WT_SIZE;i++){
		pOutBuf[i]=0;
		for(int j=1;j <= harmoNum;j += 2){		// harmoNum{܂Ői{݂̂Ȃ̂2j
			if(j%4 == 1) pOutBuf[i] += 1.f/(j*j) * _SIN(j*i);	// j=1,5,9,13,...
			else		 pOutBuf[i] -= 1.f/(j*j) * _SIN(j*i);	// j=3,7,11,15,...
		}
		pOutBuf[i] *= 8.f/(PI*PI);
	}
}

// mRMge[u
static void makeSawTable(SIGREAL* pOutBuf, int harmoNum){
	for(int i=0;i<WT_SIZE;i++){
		pOutBuf[i]=0;
		for(int j=1; j <= harmoNum; j++){
			pOutBuf[i] += 1.f/j*_SIN(j*i);
		}
		pOutBuf[i] *= 2.f/PI;
	}
}

// `ge[u
static void makeSquTable(SIGREAL* pOutBuf, int harmoNum){
	for(int i=0;i<WT_SIZE;i++){
		pOutBuf[i]=0;
		for(int j=1; j <= harmoNum; j++){
			pOutBuf[i] += 1.f/j*_SIN(j*i);
			pOutBuf[i] -= 1.f/j*_SIN(j*(i+WT_SIZE/2));
		}
		pOutBuf[i] *= 1.f/PI;
	}
}

// g`e[ȕij
static void initWaveTable(){
	static BOOL g_bFirst=TRUE;

	if(!g_bFirst) return;
	g_bFirst=FALSE;

	// TCge[u
	for(int i=0;i<WT_SIZE;i++){
		g_sinTable[i] = sin(2.f*PI*i/WT_SIZE);
	}

	// g`e[u\i30Hz`22.05KHz𕡐̑шɕꂼ̑ш̏L\jvZB
	// ̌vZ@ł́A̓p^Ƃ90^ꍇA68ɍœK
	g_tblInfoNum=0;
	int oldHarmoNum=-1;
	int j=0;
	float minFreq=30.f;	// Œg30HzƂB锭Ugł́A{sɂȂB
						// Ae[uTCYĂ{sɂȂ̂ŁAvӁB
	float fs=44100.f;	// fs44.1KƂB
						// fs48K96K̏ꍇɂŋ߂\Ɣg`e[û܂܎gƁA
						// {sɂȂB{́AfsςA{\сAg`e[u͍Đ]܂B
						// A炭͖wǕςȂƎvB
	for(int i=0;i<90;i++){
		// e[uvZ
		g_tblInfo[j].freq = minFreq * pow(fs/2/minFreq,(float)i/90);
		g_tblInfo[j].harmoNum = (int)(fs/2/g_tblInfo[j].freq);
		g_tblInfo[j].offset = j*WT_SIZE;
		// OƓ{ǂ`FbN
		if(g_tblInfo[j].harmoNum == oldHarmoNum) continue;	// Ȃ̂ŏXLbv
		oldHarmoNum = g_tblInfo[j].harmoNum;
		// Ήg߂ȂAnoteNo߂
		g_tblInfo[j].freq = fs/2/g_tblInfo[j].harmoNum;
		g_tblInfo[j].noteNo = 69.f + 12.f*log(g_tblInfo[j].freq/440.f)/log(2.f);
edPrintf("freq=%f noteNo=%f,baion=%d\n",g_tblInfo[j].freq,g_tblInfo[j].noteNo,g_tblInfo[j].harmoNum);

		j++;
	}
	g_tblInfoNum=j;
edPrintf("g_tblInfoNum=%d\n",g_tblInfoNum);

	// gш斈ɁAOpgAmRMgA`ge[u𐶐
	for(int i=0;i<g_tblInfoNum;i++){
		SIGREAL* pTable;

		pTable = &g_triTable[0] + g_tblInfo[i].offset;
		makeTriTable(pTable, g_tblInfo[i].harmoNum);

		pTable = &g_sawTable[0] + g_tblInfo[i].offset;
		makeSawTable(pTable, g_tblInfo[i].harmoNum);

		pTable = &g_squTable[0] + g_tblInfo[i].offset;
		makeSquTable(pTable, g_tblInfo[i].harmoNum);
	}

}

/////////////////////////////////////////////////////////////////////
// g`Ɋւ{Iȃ[`W

// g`e[uւ̃|C^ƁAʑi16:16Œ菬j^ƁA`ԂĔg`lǂݏo֐
__forceinline SIGREAL _GET_WAVE(SIGREAL* pTbl,int phase){
	// 16:16̌Œ菬CfbNX(=)o}NAx:Œ菬_ɂʑAy:CfbNXItZbg
	#define _IDX(x,y)	(((y)+((x)>>16))&(WT_SIZE-1))

	int idx = _IDX(phase,0);		// ̎o
	int idx2 = _IDX(phase,1);		// ԗpɁAidx̎idx߂BP+1Ɣ͈̓I[o[̉\LB
	float deci = (float)(phase & ((1<<16)-1)) / (1<<16);	// ̎o(16rbgNAA1/65536{)
	return pTbl[idx] + (pTbl[idx2] - pTbl[idx]) * deci;	// `⊮ŏo
}

// NoteNo,f`[(ZgP)px߂
static unsigned int calcWFromNoteNo(float nn,float det,float fs){
	// NoteNoAf`[l甭Ugf߂ noteNo=69(A4)440Hz
	// f`[lF100Zg1NoteNõsb`ɑ
	float f = 440.f * pow(2.f,(nn+det/100.f-69.f)/12.f);
	// px(PWT_SIZE16:16Œ菬_\)֕ϊ
	return (unsigned int)(WT_SIZE*(1<<16)*f/fs);
}

// NoteNoœKȁi{iCLXg𒴂Ȃjg`e[u߂
static SIGREAL* getWTFromNoteNo(int wf,float nn){
	if(wf==WF_SINE){
		return &g_sinTable[0];
	}else{
		// e[u\𓪂T[`B
		// ptH[}XɂȂꍇ́AnnKɐ̂offset̃}bve[ugB
		SIGREAL* pTbl = (wf==WF_TRI)?&g_triTable[0]:((wf==WF_SAW)?&g_sawTable[0]:&g_squTable[0]);
		for(int i=0;i<g_tblInfoNum;i++){
			if(nn <= g_tblInfo[i].noteNo){
				return pTbl + g_tblInfo[i].offset;
			}
		}
	}
	return &g_sinTable[0];
}


/////////////////////////////////////////////////////////////////////
// VCONX
CVCO::CVCO(){
	initWaveTable();
	m_curNn=m_nn=m_portaStartNn=0.f;
	m_p=0;
	m_pp=0.f;
	m_wf=WF_SINE;
	m_curPortaTime=1.f;
	m_portaTimeDelta=0.f;
	m_detuneCent=0.f;	// {CXԃf`[liPʂ̓Zgj
}

CVCO::~CVCO(){
}

// {CXԃf`[l(Pʂ̓Zg)̐ݒ
void CVCO::setDetune(float det){
	m_detuneCent=det;
}

// g`ސݒ
void CVCO::setWF(int wf){
	m_wf=wf%4;	// WF_SINE(=0)`WF_SQUARE(=3)
}

// |^gԐݒ
void CVCO::setPortaTime(float fVal){
	// 0b`3bB0bŃ|^gItB܂݈ʒu(fVal)ɑ΂Ďw֐Iɕω悤ɁB
	float t = exp((fVal-1)*3)*fVal*3;
	// |^gԂɉAm_portaTimeDeltavZ
	if(fVal==0.f)	m_portaTimeDelta=0.f;	// |^gȂ
	else			m_portaTimeDelta=1.f/(m_fs*t);
}

// UNoteNo̐ݒ
void CVCO::setNoteNo(int nn,BOOL isKeyOn){
	// |^g֘A̕ϐ
	if(m_curPortaTime<1.f)		m_portaStartNn = m_curNn;	// |^gJnNoteNo̓|^gNoteNo
	else						m_portaStartNn = m_nn;		// ԁJnNoteNo͍܂ł̃m[gNo
	// |^gKvǂ𔻒
	// NordLead2Synth1"Auto"ȃ|^gƂB
	// ~߁AɃ|^g悤ɂɂ́AJnisKeyOn폜B
	if(m_portaStartNn != nn && m_portaTimeDelta != 0.f
						&& isKeyOn)	m_curPortaTime = 0.f;	// |^gJn
	else							m_curPortaTime = 1.f;	// |^gsv
	// Vm[gNoێ
	m_nn = (float)nn;
}

// M
void CVCO::processSignal(int size, SIGREAL* pSig, BOOL* pProcessed){
#if 1
	// g`e[uƌŒ菬_ʑϐƐ`ԂŔg`鏈19clk/sampleiԁj

	// Synth1ƓAw֐̃|^gJ[u(x=0`1,y=0`1)
	#define		PORTAMENT_CURVE(x)		(1.f-exp(-x*4.f)*(1.f-x))

	int p=m_p;	// ptH[}X̂߁ANeBJȃ[vł͈ʑ̃oϐ𒼐ڍXV/QƂȂ
	while(size>0){
		int processSize;
		int w;
		SIGREAL* pTbl;
		if(m_curPortaTime>=1.f){
			// ԁi|^gł͂Ȃj
			// Um[gNoɉApxwƔg`e[u߂B
			w = calcWFromNoteNo(m_nn,m_detuneCent,m_fs);
			pTbl = getWTFromNoteNo(m_wf,m_nn);
			processSize = size;
		}else{
			// |^gBUgAIɕωB
			// Um[gNo߂
			m_curNn = m_portaStartNn+(m_nn-m_portaStartNn) * PORTAMENT_CURVE(m_curPortaTime);
			// Um[gNoɉApxwƔg`e[u߂B
			w = calcWFromNoteNo(m_curNn,m_detuneCent,m_fs);
			pTbl = getWTFromNoteNo(m_wf,m_curNn);
			// 1TvwČvẐAIɂ͗zAptH[}XB
			// ł́ATvɂvZȂ悤ɂB
			// Tv́A|^gJ[uy=xȒƉ肵(ۂ͎w֐)A
			// sb`̉𑜓x5Zg(K)ɂȂ悤Ɍ肷B
			// {̓|^gJ[űt֐狁߂Aʓ|Ȃ̂ŏȗB
			// ATvƕׂɂȂ邽߁AŒ24TvƂB
			// ɂāF̎ł1TvwČvZ̉Ɣʕs\B
			float totalCent = fabs(m_nn-m_portaStartNn)*100.f;
			int totalPortaSample = (int)(1.f/m_portaTimeDelta);
			processSize = MAX(24,(int)(totalPortaSample/totalCent/5.f));
			processSize = MIN(size,processSize);
			m_curPortaTime += m_portaTimeDelta*processSize;	// |^goߎԂZ
		}

		// g`ǂݏoB
		for(int i=0;i<processSize;i++){
			*pSig++ = _GET_WAVE(pTbl,p);
			p += w;		// ʑi߂
		}
		size -= processSize;
	}
	m_p=p;		// [Jʑϐoϐ֊i[

#else
	// sin()ƕ_ʑϐŔg`x[VbNȏ77clk/sample
	// ̔g`e[uƂ̃ptH[}Xrp[`B|^gȂB
	// R[h̓VvAg`e[uɔׂ4{ptH[}XB
	float p=m_pp;
	float f = 440.f * pow(2.f,(m_nn+m_detuneCent/100.f-69)/12.f);
	float w = 2*PI*f/m_fs;		// px(PQ΂̕_)
	for(int i=0;i<size;i++){
		pSig[i] = sin(p);
		p += w;					// ʑi߂
		if(p > 2.f*PI) p -= 2.f*PI;	// ʑ͈̓`FbN
	}
	m_pp=p;
#endif

	*pProcessed = TRUE;
}

/////////////////////////////////////////////////////////////////////
// {CXNX
CMyVoice::CMyVoice(){
	m_nn=m_velo=0;
	m_bKeyOn=FALSE;
}

CMyVoice::~CMyVoice(){
}

// L[IǂԂ
BOOL CMyVoice::isKeyOn(void){
	return m_bKeyOn;
}

// ǂԂB
BOOL CMyVoice::isBusy(void){
	return m_bKeyOn;	// Gx[vĂȂ̂ŁAԂ̓L[̃IItԂƓ
}

// f`[lݒ
void CMyVoice::setDetune(float det){
	// f`[l̉e󂯂̂́AVCOȂ̂ŁAVCOɃf`[lݒ
	m_vco.setDetune(det);
}

// Um[gNo̐ݒBL[IɃR[B
void CMyVoice::setNoteInfo(int nn,int velo){
	m_nn=nn;
	m_velo=velo;
	m_vco.setNoteNo(nn,isKeyOn());
}

// gK[ʒmiK[g[h(KM_MONO2)ŃK[gt@sɂ́AR[Ȃj
void CMyVoice::trigger(void){
	m_bKeyOn=TRUE;
edPrintf("VoiceNo[%d] trigger\n",m_no);
}

// L[Itʒm
void CMyVoice::release(int velo){
	m_bKeyOn=FALSE;
edPrintf("VoiceNo[%d] release\n",m_no);
}

// ݂̃m[gNoԂ
int CMyVoice::getNoteNo(void){
	return m_nn;
}

// M(m)
void CMyVoice::processSignal(int size, SIGREAL* pSig, BOOL* pProcessed){
	// VCOɐMs킹
	m_vco.processSignal(size,pSig,pProcessed);
}

// TvOgʒm
void CMyVoice::changedSamplingFreq(void){
	m_vco.setFs(m_fs);
}

/////////////////////////////////////////////////////////////////////
// VZ{̃NX
CMySynthMain::CMySynthMain(){
	m_vc.setKeyboardInfo(&m_kbdInfo);	// L[{[hǗNX{CXRg[֓o^
	m_vc.setVoiceNum(VOICE_NUM);		// {CX̐ݒ
	for(int i=0;i<VOICE_NUM;i++) m_vc.setVoice(i,&m_voice[i]);	// {CXRg[[փ{CXo^

	// 128vO
	for(int i=0;i<PROGRAM_NUM;i++){
		// lɐƂp^́AŒI128ŊāA0`1ȓɎ߂
		m_pi[i].soundParam[SPID_MASTER_VOL] = 0.1f;			// }X^[{[muʒu
		m_pi[i].soundParam[SPID_VCO_WF] = WF_TRI/128.f;		// EF[utH[
		m_pi[i].soundParam[SPID_VCO_PORTA_TIME] = 0.2f;		// |^g^Cmuʒu
		m_pi[i].soundParam[SPID_VOICE_MODE] = KM_MONO/128.f;// {CX[h
		m_pi[i].soundParam[SPID_UNISON_NUM] = 4/128.f;		// j]{CX
		strcpy(&m_pi[i].programName[0],"init");
	}
	setProgramNo(0);
}

CMySynthMain::~CMySynthMain(){
}

// e|ݒ(e|@\鎞Ɏg)
void CMySynthMain::setBaseTempo(float t){
}

// MIDIm[gItM
void CMySynthMain::receiveNoteOff(int nn,int v){
	m_kbdInfo.offKey(nn);
}

// MIDIm[gIM
void CMySynthMain::receiveNoteOn(int nn,int v){
	m_kbdInfo.onKey(nn,v);
}

// MIDI_p[Rg[M
void CMySynthMain::receiveDumperPedal(BOOL b){
	m_kbdInfo.setDumper(b);
}

// TEhp^(pb`p^)l̎M
void CMySynthMain::setSoundParam(int id,float fVal){
	// 0.f`1.fVST̃p^l0`127̐ɕϊ
	int iVal = MAX(0,MIN(127,(int)(fVal*128.f)));
edPrintf("setSoundParam id=%d,val=%f\n",id,fVal);
	// Mp^ɉāAeiɐݒsB
	switch(id){
	case SPID_MASTER_VOL:		m_masterVol = fVal;													break;
	case SPID_VCO_WF:			for(int i=0;i<VOICE_NUM;i++) m_voice[i].m_vco.setWF(iVal);			break;
	case SPID_VCO_PORTA_TIME:	for(int i=0;i<VOICE_NUM;i++) m_voice[i].m_vco.setPortaTime(fVal);	break;
	case SPID_VOICE_MODE:		m_vc.setVoiceMode(iVal);											break;
	case SPID_UNISON_NUM:		m_vc.setUnisonVoiceNum(iVal);										break;
	}
	// p^l̕ێ
	if(id >= 0 && id < SOUND_PARAM_NUM) m_curSoundParam[id] = fVal;
}

// TEhp^Ԃ
void CMySynthMain::getSoundParamName(int id,char* rtn){
	static char* names[]={"Master Volume","Wave Form","Portament Time","Voice Mode","Unison Voice Num"};
	if(id >= 0 && id < SOUND_PARAM_NUM)	strcpy(rtn,names[id]);
	else								rtn[0]='\0';
}

// TEhp^l̕\eLXgԂ
void CMySynthMain::getSoundParamValText(int id,char* rtn){
	static char* strWf[]=		{"SINE","TRIANGLE","SAW","PULSE"};
	static char* strVoiceMode[]={"POLY","MONO1","MONO2"};

	if(id >= 0 && id < SOUND_PARAM_NUM){
		int iVal = MAX(0,MIN(127,(int)(m_curSoundParam[id]*128.f)));
		switch(id){
		case SPID_VCO_WF:		sprintf(rtn,"%s",strWf[iVal%4]);				break;
		case SPID_VOICE_MODE:	sprintf(rtn,"%s",strVoiceMode[iVal%3]);			break;
		case SPID_UNISON_NUM:	sprintf(rtn,"%d",MIN(VOICE_NUM,MAX(1,iVal)));	break;
		default:				sprintf(rtn,"%.2f",m_curSoundParam[id]);		break;
		}
	}else{
		rtn[0]='\0';
	}
}

// JgvO`FW
void CMySynthMain::setProgramNo(int no){
edPrintf("setProgramNo no=%d\n",no);
	m_curSoundParam = &m_pi[no].soundParam[0];
	// VvÕp^eiɐݒ肷
	for(int id=0;id<SOUND_PARAM_NUM;id++) setSoundParam(id,m_curSoundParam[id]);
}

// VZ̏o(XeI)
void CMySynthMain::processSignalLR(int size, SIG_LR* pSig, BOOL* pProcessed){
_START_CLOCK();		// CPUNbNvJn
	// ՏԂύXĂ΁A{CX̃gK[/[X{CXRg[[ɏ
	if(m_kbdInfo.isStatusChanged()) {
		m_vc.controlVoiceTrigger();		// gK[/[X
		m_kbdInfo.resetStatusChange();	// ՏԕύXtO𗎂Ƃ
	}

	// e{CX̐MsXeIMIXi{CXRg[[̎djB
	m_vc.processSignalLR(size,pSig,pProcessed);

	// }X^[{[
	if(*pProcessed){
		float vol=m_masterVol;
		for(int i=0;i<size;i++) {
			pSig[i].l *= vol;
			pSig[i].r *= vol;
		}
	}
_DISP_CLOCK(size);	// CPUNbNvIEfBXvC㕔ɕ\
}

// TvOgʒm
void CMySynthMain::changedSamplingFreq(){
	m_vc.setFs(m_fs);
	for(int i=0;i<VOICE_NUM;i++) m_voice[i].setFs(m_fs);
}

