// synthBase.cpp
// VZ{̂ɕKvƂȂA{CXRg[Ȃǂ̎

#include <windows.h>
#include <math.h>
#include <list>
#include "common.h"
#include "debug.h"
#include "synthBase.h"


//////////////////////////////////////////
// CVoiceCtl {CXRg[NX

CVoiceCtl::CVoiceCtl(){
	m_keyMode = KM_POLY;
	m_curVoiceNo = 0;
	m_pKbdInfo = NULL;
	m_unisonNum = 1;
}

// L[{[hǗNX̐ݒ
void CVoiceCtl::setKeyboardInfo(CKeyboardInfo* p){
	m_pKbdInfo = p;
}

// {CX̐ݒ
void CVoiceCtl::setVoiceNum(int n){
	m_voiceNum=n;
	m_polyNum=n;
}

// e{CX̐ݒ
void CVoiceCtl::setVoice(int no,IVoice* pV){
	m_pVoices[no]=pV;
	pV->setNo(no);
}

// L[[hiPOLY/MONO/MONO2j̐ݒ
void CVoiceCtl::setVoiceMode(int mode){
	m_keyMode = mode%3;	// 0,1,2
	// sv{CX́A[XAJg{CX擪
	for(int i=(m_keyMode == KM_POLY)?m_polyNum:m_unisonNum; i<m_voiceNum;i++){
		if(m_pVoices[i]->isKeyOn()) m_pVoices[i]->release(0);
		m_onVoices.remove(m_pVoices[i]);
	}
	m_curVoiceNo = -1;

}

// j]{CX̐ݒ
void CVoiceCtl::setUnisonVoiceNum(int n){
	n = MIN(m_voiceNum,MAX(1,n));
	if(n == m_unisonNum) return;
	// j]{CXݒ
	m_unisonNum = n;

	// j]{CXɉāA{CXԂ̃f`[lAplvZAݒ肷
	// E{CXԂ̃f`[͈ꗥA10centƂĂ݂B
	// E{CXp͍ς(=0)Eς(=1)ɋϓɎU炷
	// ł̃f`[lpľߕ͒PȂB
	float detSpread = 10.f;	
	for(int i=0;i<m_voiceNum;i++){
		int vn = i%m_unisonNum;
		float det = vn*detSpread-detSpread*(m_unisonNum-1)/2.f;
		float pan = (m_unisonNum==1)?0.5f : vn*1.f/(m_unisonNum-1);
		m_pVoices[i]->setDetune(det);
		m_pVoices[i]->setPan(pan);
	}

	// sv{CX́A[XAJg{CX擪
	for(int i=(m_keyMode == KM_POLY)?m_polyNum:m_unisonNum; i<m_voiceNum;i++){
		if(m_pVoices[i]->isKeyOn()) m_pVoices[i]->release(0);
		m_onVoices.remove(m_pVoices[i]);
	}
	m_curVoiceNo = -1;
}

// 󂫃{CX̃T[`
IVoice* CVoiceCtl::getNextOffVoice(){
	int curVoiceNo = m_curVoiceNo;
	for(int i=0;i<m_polyNum;i++){
		curVoiceNo++;
		if(curVoiceNo >= m_polyNum) curVoiceNo = 0;
		if(!m_pVoices[curVoiceNo]->isKeyOn()) return m_pVoices[curVoiceNo];
	}
	// ǂIB
	return NULL;
}

// ՏƊe{CX̏ԓAgK[/[X𐧌䂷
void CVoiceCtl::controlVoiceTrigger(){

	if(m_keyMode == KM_POLY)	controlVoicePoly();
	else						controlVoiceMono();
}

// |[h̃gK[/[X𐧌
void CVoiceCtl::controlVoicePoly(){
	//// ܂L[[X
	// I{CXXg݂āAL[{[he[uŃm[gIt(xVeBl=0)
	// ȂĂ邩`FbNm[gItȂ烊[X
	for(std::list<IVoice*>::iterator v=m_onVoices.begin();v != m_onVoices.end();){
		if(m_pKbdInfo->getVelocity((*v)->getNoteNo())==0){
			(*v)->release(0);
			v=m_onVoices.erase(v);
		}else v++;
	}

	//// gK[
	// VKɉꂽL[ΏۂɏsB
	int num=MIN(m_polyNum,m_pKbdInfo->getOnKeyNum());	// őm[g̓|ƉL[̂ǂ炩Ȃ
	for(int i=0;i<num;i++){
		int noteNo = m_pKbdInfo->getNewOnKeyNN(i);		// VKL[iԖڂɐVL[̃m[gNOiNEWL[tOtj
		if(noteNo == -1) break;							// VKL[͂ȂȏÂVKȂ͂Ȃ̂ŏI

		// ɓm[gNo𔭉Ă{CX΁A[XB
		// Ⴆ΃AyWG[^ŃQ[g^CPOOƂɁȂΉȂ΁AǂǂdȂĂB
		// ́ÃASYłnote on/off͌Ղ̏ԂύX邾ŁAꎞoffon̏œɂꍇA
		// ʓInoteoff͖鎖ɂȂ邽߁B
		// ̂悤ȎɂȂȂ߂ɁAm[g̕{CX͕sƂB
		for(std::list<IVoice*>::iterator v=m_onVoices.begin();v != m_onVoices.end();){
			if((*v)->getNoteNo()==noteNo){
				(*v)->release(0);
				v=m_onVoices.erase(v);
			}else v++;
		}

		// j]{CX̐AgK[
		IVoice* pUnisonMasterVoice;
		for(int u = 0; u < m_unisonNum; u++){
			//// gK[{CX̌
			// L[ItĂ{CX擾BSrW[AԌÂIɂȂĂ{CX擾
			// Ax[X͏Ȃǂ̍Hv̗]n͂
			IVoice* v = getNextOffVoice();
			if(v == NULL){
				v = m_onVoices.front();	// IňԌÂ{CX
				if(v == NULL) return;
				m_onVoices.pop_front();
			}
			m_curVoiceNo = v->getNo();
			if(u==0) pUnisonMasterVoice = v; // j\}X^[{CX̑ޔ

			// m[gNO̐ݒƃgK[
			v->setNoteInfo(noteNo,m_pKbdInfo->getVelocity(noteNo));
			v->setUnisonInfo(pUnisonMasterVoice,m_unisonNum,u);
			v->trigger();

			// I{CXXg֒ǉ
			m_onVoices.push_back(v);
		}
	}
}

// m[h̃gK[/[X𐧌
void CVoiceCtl::controlVoiceMono(){
	// ȂɂL[ĂȂ΁Ã݂I{CX[XďI
	if(m_pKbdInfo->getOnKeyNum()==0){
		for(int i=0;i < m_unisonNum; i++){
			m_onVoices.remove(m_pVoices[i]);
			if(m_pVoices[i]->isKeyOn()) m_pVoices[i]->release(0);
		}
		m_monoCurrentVelocity = 0;
		return;
	}

	// ȂɂL[Ă̂ňԐVՂƂĂāAKv
	// 1.VK̉Ȃ疳ɔ
	// 2.VKł͂ȂꍇA{CXIłȂAIłm[gNOႦΔ
	BOOL bProcess=FALSE;
	int noteNo = m_pKbdInfo->getNewOnKeyNN(0);
	if(noteNo != -1){
		bProcess=TRUE;
		m_monoCurrentVelocity = m_pKbdInfo->getVelocity(noteNo);
	}else{
		// VKł͂ȂL[ꂽʁA鎖ɂȂm[g
		// ̃xVeB͗ꂽL[ƓƂBāAm_monoCurrentVelocity͍XVȂB
		noteNo = m_pKbdInfo->getOnKeyNN(0);
		if(!m_pVoices[0]->isKeyOn() || m_pVoices[0]->getNoteNo() != noteNo) bProcess = TRUE;
	}

	if(!bProcess) return;	// sv

	// 
	IVoice* pUnisonMasterVoice = m_pVoices[0];	// j]}X^[͏Ƀ{CXԍ[
	if(m_keyMode==KM_MONO){
		// m[h
		// KgK[
		for(int i=0;i < m_unisonNum; i++) {
			IVoice* v = m_pVoices[i];
			// m[gNO̐ݒƃgK[
			v->setNoteInfo(noteNo,m_monoCurrentVelocity);
			v->setUnisonInfo(pUnisonMasterVoice,m_unisonNum,0);
			v->trigger();

			// I{CXXg֒ǉ (łɓo^Ă\̂ŁAx폜Ăǉ)
			m_onVoices.remove(v);
			m_onVoices.push_back(v);
		}
	}else if(m_keyMode==KM_MONO2){
		// K[gm[h
		// ݃L[Itꍇ̂݃gK[
		for(int i=0;i < m_unisonNum; i++) {
			IVoice* v = m_pVoices[i];
			// m[gNO̐ݒƃgK[
			v->setNoteInfo(noteNo,m_monoCurrentVelocity);
			if(!v->isKeyOn()){
				// ݃L[ItgK[AI{CXXg֒ǉ
				v->setUnisonInfo(pUnisonMasterVoice,m_unisonNum,0);
				v->trigger();
				m_onVoices.push_back(v);
			}else{
				// ݃IgK[Ȃ
			}
		}
	}
}

// Mie{CX̐MsAXeIMIXj
void CVoiceCtl::processSignalLR(int size, SIG_LR* pSig, BOOL* pProcessed){
	// {CX̐Mmobt@ɏo͂AXeIMIXĂB
	CACHE_ALIGN16 SIGREAL monoSig[MAX_SIGBUF];
	int processedVoiceNum=0;
	for(int i=0;i<m_voiceNum;i++){
		// {CXɐMs
		if(!m_pVoices[i]->isBusy()) continue;	// łȂ΁A˗Ȃ
		BOOL voiceProcessed=FALSE;
		m_pVoices[i]->processSignal(size,monoSig,&voiceProcessed);	// M
		if(!voiceProcessed) continue;			// MĂȂ̂ŁAȂ

		// monoo͂XeIMIX
		// ߂ĂMIXȂA܂o̓obt@𖳉ɂ
		if(processedVoiceNum == 0) for(int j=0;j<size;j++) pSig[j].l = pSig[j].r = 0;
		float pan = m_pVoices[i]->getPan();
		float lGain = (pan<0.5f) ? 1.f : (1.f-pan)*2.f;
		float rGain = (pan>0.5f) ? 1.f : pan*2.f;
		for(int j=0;j<size;j++){
			pSig[j].l += monoSig[j]*lGain;
			pSig[j].r += monoSig[j]*rGain;
		}
		processedVoiceNum++;
		*pProcessed = TRUE;
	}
}

